#include <stdio.h>
#include <math.h>

#include "if2.h"


void                 If2Read();                           /* if2read.c        */

void      ReadModuleDataBase(),  WriteModuleDataBase();   /* if2modules.c     */
void          AddModuleStamp();
PMDATA          LookupCallee();
PMDATA          LookupCaller();

double                TSECND();                           /* if2timer.c       */
void            StopProfiler();
void           StartProfiler();

void              EnterScope(),            MakeGraph();   /* if2build.c       */
void                MakeInfo(),             MakeEdge();
void               MakeConst(),             MakeNode();
void            MakeCompound(),            ExitScope();
void                AddStamp(),          RemoveStamp();
void    AssignSourceFileName(),              MakeAde();
int                  IsStamp();
PINFO               FindInfo();

void              LinkImport(),           LinkExport();   /* if2util.c        */
void            UnlinkImport(),         UnlinkExport();
void         UnlinkAdeImport(),      UnlinkAdeExport();
void           LinkAdeImport(),        LinkAdeExport();
PNODE          FindLastGraph(),         FindFunction();
PNODE              LinkGraph(),         FindLastNode();
PNODE               LinkNode();
PNODE             UnlinkNode();
PNODE            UnlinkGraph();
char             *CopyString(),             *MyAlloc();
void                Warning1(),               Error1();
void                  Error2();
PALIST        LinkAssocLists();
PEDGE              EdgeAlloc();
PNODE              NodeAlloc();
PINFO              InfoAlloc();
PADE                AdeAlloc();
PALIST        AssocListAlloc();
PEDGE             FindImport();
PEDGE             FindExport();
int               UsageCount();
int             IsAdePresent();

void                If2Write();                           /* if2write.c       */

void                 If2Cost(),         ReadCostFile();   /* if2cost.c        */
double    NumberOfIterations();

void                 If2Part();                           /* if2part.c        */
int           IsVecCandidate();
int              IsInnerLoop();

void                If2Count();                           /* if2count.c       */

void           WriteNodeName();                           /* if2.c            */

void                    Stop(),                 main();   /* DRIVER FILE      */

int                   strlen();                           /* C LIBRARY STUFF  */
char                 *strcpy();

#ifndef RS6000
char                 *malloc();
int                     free();
#endif

#ifdef CRAY
double                  atof();
#endif


#define OK       0                               /* PROGRAM EXIT STATUS CODES */
#define ERROR    1

#define FALSE    0
#define TRUE     1

extern FILE  *input;                             /* IF1 INPUT  STREAM         */
extern FILE  *output;                            /* IF1 OUTPUT STREAM         */

extern char  *program;                           /* PROGRAM NAME              */

extern char *sfile;                              /* SISAL FILE BEING READ     */
extern PNODE cfunct;                      /* FUNCTION BEING BUILT OR EXAMINED */

extern int    info;               /* DUMP OPTIMIZATION INFO TO stderr?        */
extern int    vinfo;              /* DUMP VECTOR-CONCURRENT INFO              */
extern int    sgnok;              /* ARE SIGNED ARITHMETIC CONSTANTS ALLOWED? */

extern int    maxint;                   /* MAXIMUM INTEGER READ FROM IF1 FILE */
extern PINFO  integer;                  /* INTEGER SYMBOL TABLE ENTRY         */
extern int    line;        /* LINE NUMBER OF PREVIOUSLY READ LINE OF IF1 FILE */

extern PINFO  ihead;                    /* SYMBOL TABLE HEAD POINTER          */
extern PINFO  itail;                    /* SYMBOL TABLE TAIL POINTER          */

extern PNODE  glstop;                   /* HEADER OF FUNCTION GRAPH LIST      */
extern char  *stamps[];                 /* ARRAY OF IF1 STAMPS 0 to 127       */
extern char  *cnames[];                 /* COMPOUND NODE NAMES                */
extern char  *snames[];                 /* SIMPLE NODE NAMES                  */
extern char  *atnames[];                /* IF2 AT-NODE NAMES                  */
extern char  *gnames[];                 /* GRAPH NODE NAMES                   */
extern PRAGS  pragmas;        /* PRAGMAS FORM CURRENTLY READ LINE OF IF1 FILE */

extern double mcosts[];                 /* MISC COST TABLE                    */
extern double scosts[];                 /* SIMPLE NODE COST TABLE             */
extern double atcosts[];                /* AT-NODE COST TABLE                 */

extern int level;                       /* NESTED LOOP PARTITION THRESHOLD    */
extern int atlevel;            /* ONLY SLICE AT THIS PARALLEL NESTING LEVEL   */

extern int streams;
extern int cycle;

extern int nopred;
extern int dovec;

extern int procs;             /* NUMBER OF AVAILABLE PROCESSORS IN THE SYSTEM */
extern int cRay;                                     /* VECTORIZE FOR A CRAY? */
extern int vadjust;                     /* VECOTIZATION COST ADJUSTMENT VALUE */

extern int prof;                        /* PROFILE THE OPTIMIZER?             */

extern char *mdbfile;                                 /* USE MODULE DATA BASE */
